# 4. Detection of PCR primer changes

[Polymerase chain reactions (PCR)](https://en.wikipedia.org/wiki/Polymerase_chain_reaction) uses small nucleotide sequence snippets called "primers" that are [complementary](<https://en.wikipedia.org/wiki/Complementarity_(molecular_biology)>) to a specific region of the virus genome. High similarity between primers and the genome region they are supposed to bind to is required for PCR to work. Changes in the virus genome can interfere with this requirement. If Nextclade is provided with a table of PCR primers (in CSV format), it can analyze these regions in query sequences and report changes that may indicate reduced primer binding.

For each primer, Nextclade finds and records a corresponding range in the reference sequence. It then verifies if any of the mutations in the aligned query sequence (identified in the "Nucleotide mutation calling" step) fall in any of these primer ranges, and if so, reports these mutations as PCR primer changes.

This step only runs if a PCR primer table is provided. PCR primers are specific to a virus and to a particular reference sequence. It can fail if PCR primers provided do not have high similarity with any part of the reference sequence, so care should be taken that they are compatible.

### Results

PCR primer changes are reported in the tooltip of the "Mut." (short for "Mutations") column in the results table in [Nextclade Web](../nextclade-web).

They are a included into the analysis results JSON, CSV and TSV files generated by [Nextclade CLI](../nextclade-cli) and in the "Download" dialog of [Nextclade Web](../nextclade-web).
