#pragma once

#include <numeric>

namespace Nextclade {
  template<typename T>
  int calculateTotalLength(const safe_vector<T>& items) {
    return std::accumulate(items.cbegin(), items.cend(), 0,//
      [](int result, const auto& item) { return result + item.length; });
  }
}// namespace Nextclade
